package com.ruoyi.mall.service;

import com.ruoyi.common.core.domain.RegionTreeSelect;
import com.ruoyi.mall.domain.MallRegion;

import java.util.List;
import java.util.stream.Stream;

/**
 * 省市区Service接口
 *
 * @author ruoyi
 * @date 2022-07-15
 */
public interface IMallRegionService
{
    /**
     * 查询省市区
     *
     * @param id 省市区主键
     * @return 省市区
     */
    public MallRegion selectMallRegionById(Integer id);

    /**
     * 查询省市区列表
     *
     * @param mallRegion 省市区
     * @return 省市区集合
     */
    public List<MallRegion> selectMallRegionList(MallRegion mallRegion);

    /**
     * 查询省市区列表
     *
     * @return 省市区集合
     */
    public List<RegionTreeSelect> buildRegionTreeList();

    /**
     * 查询省市区列表
     *
     * @return 省市区集合
     */
    public List<MallRegion> selectList(Integer pid);

    /**
     * 新增省市区
     *
     * @param mallRegion 省市区
     * @return 结果
     */
    public int insertMallRegion(MallRegion mallRegion);

    /**
     * 修改省市区
     *
     * @param mallRegion 省市区
     * @return 结果
     */
    public int updateMallRegion(MallRegion mallRegion);

    /**
     * 批量删除省市区
     *
     * @param ids 需要删除的省市区主键集合
     * @return 结果
     */
    public int deleteMallRegionByIds(Integer[] ids);

    /**
     * 删除省市区信息
     *
     * @param id 省市区主键
     * @return 结果
     */
    public int deleteMallRegionById(Integer id);

    /**
     * 根据上级id获取省市区列表（0-省级）
     *
     * @return 行政区域集合
     */
    public List<MallRegion> getRegionByPid(Integer pid);
}
